<?php
/*********************************************************************************

Plugin Name: Blogroll OPML Export
Plugin URI: http://www.nitallica.org/free-wordpress-plugins/
Description: Based on Perishable's <a href="http://perishablepress.com/press/2007/07/11/wordpress-plugin-export-blogroll-for-delicious/">Export Blogroll for del.icio.us</a> plugin, this plugin will allow you to export your WordPress blogroll in OPML format for importing to Blogrolling.com or other similar blogroll services. 
Author: Nicki Faulk
Author URI: http://www.nitallica.org/
Version: 0.1
Disclaimer: Use at your own risk. No warranty expressed or implied is provided. There is no guarantee that this will work for your version of WordPress, I wrote this out of need for myself and am sharing in the hopes someone else finds it useful.

*********************************************************************************/

/***** COPYRIGHT/PERMISSION NOTICE **********************************************

You are free: 
 * to Share  to copy, distribute and transmit the work
 * to Remix  to adapt the work
 
Under the following conditions:
	 * Attribution. You must attribute the work in the manner specified by the author or licensor (but not in any way that suggests that they endorse you or your use of the work).
	 * Noncommercial. You may not use this work for commercial purposes.
	 * Share Alike. If you alter, transform, or build upon this work, you may distribute the resulting work only under the same or similar license to this one.
 * For any reuse or distribution, you must make clear to others the license terms of this work. The best way to do this is with a link to this web page.
 * Any of the above conditions can be waived if you get permission from the copyright holder.
 * Nothing in this license impairs or restricts the author's moral rights.
 
You can view a copy of this license here: http://creativecommons.org/licenses/by-nc-sa/3.0/

*********************************************************************************/

/***** INSTRUCTIONS **************************************************************

1. Upload the blogroll-opml-export.php file to WordPress plugins directory and activate on the Plugins page in WP-Admin
2. Go to Options > Export Blogroll
3. Copy the exported links from the textarea box into a blank text file and save as FILENAME_OF_YOUR_CHOICE.opml 
4. Import as needed. For importing into WordPress, go to Blogroll > Import Links

*********************************************************************************/

function add_blogroll_opml_admin() {
	if (function_exists('add_options_page')) {
		add_options_page('Blogroll OPML Export', 'Blogroll OPML Export', 8, basename(__FILE__), 'blogroll_opml_admin');
	}
}

function blogroll_opml_admin() {
	global $wpdb;
	$links = "SELECT link_url, link_name FROM $wpdb->links ORDER BY link_id DESC";
	$posts = $wpdb->get_results($links);

	echo '<div class="wrap"><h2>Export your WordPress Blogroll for import to WordPress</h2>';
	echo '<p>Copy and paste into a blank text file and save as FILENAME_OF_YOUR_CHOICE.opml</p></div>';
	echo '<div class="wrap"><p>[ Exported OPML format ]</p>';
	echo '<form><p><input type=button value="Highlight All" onClick="javascript:this.form.exported.focus();this.form.exported.select();" /></p>';
	echo '<textarea name="exported" style="width:99%;height:333px;">';
	echo '<!--  OPML generated by WordPress -->
<opml version="1.1">
<head>
<title/>
<dateModified/>
<ownerName>Blogroll Owner</ownerName>
<ownerEmail>opml@blogrolling.com</ownerEmail>
</head>
<body>';

	if($posts){
		foreach ($posts as $post){
			$link_url  = stripslashes($post->link_url);
			$link_name = stripslashes($post->link_name);
			$string = '
<outline text="' . $link_name . '" type="link" url="' . $link_url . '" lastmod="" target="" isRecent="true" />';
			echo $string;
		}
	}
	
	echo '
</body>
</opml>';
	echo '</textarea></form></div>';
}

add_action('admin_menu', 'add_blogroll_opml_admin');
?>